struct macro *macros;
unsigned macro_count = 0;

struct macro *is_macro(char *fnc)
{
  unsigned n = macro_count;

  while(n--)
  {
    if(!strncmp(macros[n].name, fnc, macros[n].len) && fnc[macros[n].len] == '(')
      return &macros[n];
  }
  return 0;
}

char *skip_parenthesis(char *str);

struct macro_arg
{
  unsigned char len;
  char *arg;
};

int parse_macro(char *fnc, char *result, struct macro *macro)
{
  char *rptr = result;
  char *mptr = macro->function;
  char c;
  unsigned char a;
  struct macro_arg args[MAX_ARGS];
  char *varg;
  unsigned char argcnt = 0;
  char *ptr,*ptr2;
  unsigned n, l;

  fnc = strchr(fnc, '(')+1;

  while(argcnt < MAX_ARGS)
  {
    args[argcnt].arg = fnc;
    ptr = strpbrk(fnc, ";,)");
    if(!ptr) break;

    if(ptr2 = memchr(fnc, '(', ptr-fnc))
    ptr = skip_parenthesis(ptr2);
    args[argcnt++].len = ptr-fnc;
    fnc = ptr + 1;
  }

  while(c = *mptr++)
  {
    if(c == '%')
      if(*mptr == '%')
      {
        *rptr++ = '%';
        *rptr++ = '%';
        mptr++;
      }
      else
      {
        a = strtoul(mptr, &mptr, 10);
        if(argcnt < a--)
          break;
        memcpy(rptr, args[a].arg, args[a].len);
        rptr += args[a].len;
      }
    else
      *rptr++ = c;
  }

/*  varg = strstr(result, "%%");
  if(varg && argcnt > macro->max_args)
  {
    ptr = strrchr(args[macro->max_args].arg, ')');
    if(!ptr) return 0;
    n = ptr - args[macro->max_args].arg;
    memmove(&varg[n], &varg[2], l = strrchr(&varg[1], ')')+1-&varg[2]);
    memcpy(varg, args[macro->max_args].arg, n);
    varg[n+l] = 0;
  }*/
  for(ptr2=result;(varg = strstr(ptr2, "%%")) && argcnt > macro->max_args;ptr=&varg[n+l])
  {
    ptr = strrchr(args[macro->max_args].arg, ')');
    if(!ptr) return 0;
    n = ptr - args[macro->max_args].arg;
    memmove(&varg[n], &varg[2], l = strrchr(&varg[1], ')')+1-&varg[2]);
    memcpy(varg, args[macro->max_args].arg, n);
    varg[n+l] = 0;
  }

  return 1;
}

struct cell *new_temp_cell(void);
int calculate_cell_result(struct sheet *sheet, struct cell *cell);
struct celllist cells_from_args(struct sheet *sheet, char *args, struct cell *rcell, unsigned argcnt, char **);
int add_refs(struct celllist *cells, struct cell *cell);

int run_macro(struct sheet *sheet, char *fnc, struct macro *macro, struct cell *tcell)
{
  int rc;
  struct celllist cells;
  struct cell *cell;

  if(macro->max_args)
  {
    cells = cells_from_args(sheet, (&fnc[macro->len])+2, tcell, -1, 0);
    if(cells.count == -1) return 0;
    add_refs(&cells, tcell);
    free(cells.cells);
  }

  cell = new_temp_cell();
  if(!cell) return 0;
  cell->value[0] = '=';
  parse_macro(fnc, &cell->value[1], macro);
  rc = calculate_cell_result(sheet, cell);
  memcpy(&tcell->result, &cell->result, sizeof(union cell_result));
  tcell->restype = cell->restype;
  tcell->len = cell->len;
  tcell->error = cell->error;
  return rc;
}

struct macro *new_macro(void)
{
  void *ptr;

  if(!macro_count)
  {
    macros = malloc(sizeof(struct macro));
    if(!macros) return 0;
  }
  else
  {
    ptr = realloc(macros, (1+macro_count)*sizeof(struct macro));
    if(!ptr) return 0;
    macros = ptr;
  }
  return &macros[macro_count++];
}

int init_macros(void)
{
  FILE *fp = fopen("macros.clc", "r");
  char buff[MACRO_LEN+MACRONAME_LEN+1];
  struct macro *macro;
  unsigned l;
  char *ptr;

  if(!fp)
  {
    show_status_getch("Loading macros failed - cannot open MACROS.CLC");
    return 0;
  }
  puts("Loading macros...");

  while(fgets(buff, sizeof(buff), fp))
  {
    macro = new_macro();
    if(!macro)
      return 1;
    if(buff[l = (strlen(buff)-1)] == '\n')
      buff[l] = 0;
    ptr = strchr(buff, ' ');
    if(!ptr)
    {
      printf("Syntax error in macro: %s\n", buff);
      return 1;
    }
    macro->len = ptr - buff;
    *ptr = 0;
    strcpy(macro->name, buff);
    ptr++;
    strcpy(macro->function, ptr);

    for(macro->max_args=0,ptr=macro->function;ptr=strchr(ptr,'%');)
    {
      ptr++;
      if(*ptr != '%')
      {
        l = strtoul(ptr, &ptr, 10);
        if(l > macro->max_args)
          macro->max_args = l;
      }
      else ptr++;
    }

    printf("Initialized macro %s with %u args: %s\n", macro->name, macro->max_args, macro->function);
  }

  fclose(fp);

  return 0;
}

